(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/common'), require('@angular/cdk/observers')) :
    typeof define === 'function' && define.amd ? define('@nowzoo/ngx-bootstrap-popup', ['exports', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/common', '@angular/cdk/observers'], factory) :
    (factory((global.nowzoo = global.nowzoo || {}, global.nowzoo['ngx-bootstrap-popup'] = {}),global.rxjs,global.rxjs.operators,global.ng.core,global.ng.common,global.ng.cdk.observers));
}(this, (function (exports,rxjs,operators,core,common,observers) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapPopupPlaceholderComponent = /** @class */ (function () {
        function NgxBootstrapPopupPlaceholderComponent() {
            this.contentChanged = new core.EventEmitter();
        }
        Object.defineProperty(NgxBootstrapPopupPlaceholderComponent.prototype, "inserted", {
            get: /**
             * @return {?}
             */ function () {
                return this._inserted;
            },
            set: /**
             * @param {?} inserted
             * @return {?}
             */ function (inserted) {
                this._inserted = inserted;
                if (inserted instanceof core.TemplateRef) {
                    this._template = inserted;
                }
                else {
                    this._template = this.defaultTemplate;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopupPlaceholderComponent.prototype, "template", {
            get: /**
             * @return {?}
             */ function () {
                return this._template;
            },
            enumerable: true,
            configurable: true
        });
        NgxBootstrapPopupPlaceholderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-bootstrap-popup-placeholder',
                        template: "\n    <div #insertedContent (cdkObserveContent)=\"contentChanged.emit($event)\">\n      <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n    <ng-template #defaultTemplate>{{inserted}}</ng-template>\n  ",
                        styles: [':host {display: none;}']
                    }] }
        ];
        NgxBootstrapPopupPlaceholderComponent.propDecorators = {
            defaultTemplate: [{ type: core.ViewChild, args: ['defaultTemplate',] }],
            insertedContent: [{ type: core.ViewChild, args: ['insertedContent',] }]
        };
        return NgxBootstrapPopupPlaceholderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ NgxBootstrapPopup = /** @class */ (function () {
        function NgxBootstrapPopup(_elementRef, _cfr, _vcr) {
            this._elementRef = _elementRef;
            this._cfr = _cfr;
            this._vcr = _vcr;
            this._ngUnsubscribe = new rxjs.Subject();
            this._showing = false;
            this.clickDismissListener = null;
            this.events = new core.EventEmitter();
        }
        Object.defineProperty(NgxBootstrapPopup.prototype, "titleComponentRef", {
            get: /**
             * @return {?}
             */ function () {
                return this._titleComponentRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "contentComponentRef", {
            get: /**
             * @return {?}
             */ function () {
                return this._contentComponentRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "cfr", {
            get: /**
             * @return {?}
             */ function () {
                return this._cfr;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "vcr", {
            get: /**
             * @return {?}
             */ function () {
                return this._vcr;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "el", {
            get: /**
             * @return {?}
             */ function () {
                return this._elementRef.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "$el", {
            get: /**
             * @return {?}
             */ function () {
                return jQuery(this.el);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "bsInstance", {
            get: /**
             * @return {?}
             */ function () {
                return this.$el.data('bs.' + this.popupType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "showing", {
            get: /**
             * @return {?}
             */ function () {
                return this._showing;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopup.prototype, "jQueryEvents", {
            get: /**
             * @return {?}
             */ function () {
                var _this = this;
                return ['show', 'inserted', 'shown', 'hide', 'hidden'].map((( /**
                 * @param {?} t
                 * @return {?}
                 */function (t) { return t + ".bs." + _this.popupType; }))).join(' ');
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.create();
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._ngUnsubscribe.next();
                this._ngUnsubscribe.complete();
                this.$el[this.popupType]('dispose');
                this.$el.off(this.jQueryEvents, this.bsEventListener);
                if (this.clickDismissListener) {
                    jQuery('body').off('click focusin', this.clickDismissListener);
                }
                if (this.titleComponentRef) {
                    this.titleComponentRef.destroy();
                }
                if (this.contentComponentRef) {
                    this.contentComponentRef.destroy();
                }
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.create = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.bsEventListener = (( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    if (_this.dismissOnClickOutside && event.type === 'shown') {
                        _this.clickDismissListener = (( /**
                         * @param {?} clickEvent
                         * @return {?}
                         */function (clickEvent) {
                            if (_this.bsInstance.tip.contains(clickEvent.target)) {
                                return;
                            }
                            jQuery('body').off('click focusin', _this.clickDismissListener);
                            _this.clickDismissListener = null;
                            _this.hide();
                        }));
                        jQuery('body').on('click focusin', _this.clickDismissListener);
                    }
                    if (event.type === 'show') {
                        _this._showing = true;
                    }
                    if (event.type === 'hidden') {
                        jQuery('body').off('click focusin', _this.clickDismissListener);
                        _this.clickDismissListener = null;
                        _this._showing = false;
                    }
                    _this.events.emit(event);
                }));
                this.$el.on(this.jQueryEvents, this.bsEventListener);
                /** @type {?} */
                var options = this.getOptions();
                this.$el[this.popupType](options);
                this.updateEnabled();
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.getOptions = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var options = Object.assign({}, this.options);
                if (this.title) {
                    this._titleComponentRef = this.getPlaceholderComponent();
                    this.titleComponentRef.instance.inserted = this.title;
                    options.title = this.titleComponentRef.instance.insertedContent.nativeElement;
                    options.html = true;
                }
                if (this.content) {
                    this._contentComponentRef = this.getPlaceholderComponent();
                    this.contentComponentRef.instance.inserted = this.content;
                    options.content = this.contentComponentRef.instance.insertedContent.nativeElement;
                    options.html = true;
                }
                return options;
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.getPlaceholderComponent = /**
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var factory = this.cfr.resolveComponentFactory(NgxBootstrapPopupPlaceholderComponent);
                /** @type {?} */
                var ref = this.vcr.createComponent(factory, 0);
                ref.instance.contentChanged
                    .pipe(operators.takeUntil(this._ngUnsubscribe))
                    .subscribe(( /**
             * @return {?}
             */function () {
                    if (_this.showing) {
                        _this.update();
                    }
                }));
                return ref;
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.show = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('show');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.hide = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('hide');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.toggle = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('toggle');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.enable = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('enable');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.disable = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('disable');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.toggleEnabled = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('toggleEnabled');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.update = /**
         * @return {?}
         */
            function () {
                this.$el[this.popupType]('update');
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.updateTitle = /**
         * @return {?}
         */
            function () {
                if (this.titleComponentRef && this.title) {
                    this.titleComponentRef.instance.inserted = this.title;
                }
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.updateContent = /**
         * @return {?}
         */
            function () {
                if (this.contentComponentRef && this.content) {
                    this.contentComponentRef.instance.inserted = this.content;
                }
            };
        /**
         * @return {?}
         */
        NgxBootstrapPopup.prototype.updateEnabled = /**
         * @return {?}
         */
            function () {
                if (this.bsInstance) {
                    if (this.enabled) {
                        this.enable();
                    }
                    else {
                        this.disable();
                    }
                }
            };
        return NgxBootstrapPopup;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapPopoverDirective = /** @class */ (function (_super) {
        __extends(NgxBootstrapPopoverDirective, _super);
        function NgxBootstrapPopoverDirective(elementRef, cfr, vcr) {
            var _this = _super.call(this, elementRef, cfr, vcr) || this;
            _this.popoverEnabled = true;
            _this.popoverDismissOnClickOutside = true;
            _this.popoverEvents = _this.events;
            return _this;
        }
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "popupType", {
            get: /**
             * @return {?}
             */ function () {
                return 'popover';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "content", {
            get: /**
             * @return {?}
             */ function () {
                return this.popoverContent || null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "title", {
            get: /**
             * @return {?}
             */ function () {
                return this.popoverTitle || null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "dismissOnClickOutside", {
            get: /**
             * @return {?}
             */ function () {
                return this.popoverDismissOnClickOutside;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "enabled", {
            get: /**
             * @return {?}
             */ function () {
                return this.popoverEnabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "options", {
            get: /**
             * @return {?}
             */ function () {
                return this.popoverOptions || null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        NgxBootstrapPopoverDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes.popoverEnabled !== undefined) {
                    this.updateEnabled();
                }
                if (changes.popoverTitle) {
                    this.updateTitle();
                }
                if (changes.popoverContent) {
                    this.updateContent();
                }
            };
        NgxBootstrapPopoverDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxBootstrapPopover]'
                    },] }
        ];
        /** @nocollapse */
        NgxBootstrapPopoverDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.ComponentFactoryResolver },
                { type: core.ViewContainerRef }
            ];
        };
        NgxBootstrapPopoverDirective.propDecorators = {
            popoverTitle: [{ type: core.Input }],
            popoverContent: [{ type: core.Input }],
            popoverEnabled: [{ type: core.Input }],
            popoverDismissOnClickOutside: [{ type: core.Input }],
            popoverOptions: [{ type: core.Input }],
            popoverEvents: [{ type: core.Output }]
        };
        return NgxBootstrapPopoverDirective;
    }(NgxBootstrapPopup));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapTooltipDirective = /** @class */ (function (_super) {
        __extends(NgxBootstrapTooltipDirective, _super);
        function NgxBootstrapTooltipDirective(elementRef, cfr, vcr) {
            var _this = _super.call(this, elementRef, cfr, vcr) || this;
            _this.tooltipEnabled = true;
            _this.tooltipDismissOnClickOutside = true;
            _this.tooltipEvents = _this.events;
            return _this;
        }
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "popupType", {
            get: /**
             * @return {?}
             */ function () {
                return 'tooltip';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "content", {
            get: /**
             * @return {?}
             */ function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "title", {
            get: /**
             * @return {?}
             */ function () {
                return this.tooltipTitle || null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "dismissOnClickOutside", {
            get: /**
             * @return {?}
             */ function () {
                return this.tooltipDismissOnClickOutside;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "enabled", {
            get: /**
             * @return {?}
             */ function () {
                return this.tooltipEnabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "options", {
            get: /**
             * @return {?}
             */ function () {
                return this.tooltipOptions || null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        NgxBootstrapTooltipDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if (changes.tooltipEnabled !== undefined) {
                    this.updateEnabled();
                }
                if (changes.tooltipTitle) {
                    this.updateTitle();
                }
            };
        NgxBootstrapTooltipDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxBootstrapTooltip]'
                    },] }
        ];
        /** @nocollapse */
        NgxBootstrapTooltipDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.ComponentFactoryResolver },
                { type: core.ViewContainerRef }
            ];
        };
        NgxBootstrapTooltipDirective.propDecorators = {
            tooltipTitle: [{ type: core.Input }],
            tooltipEnabled: [{ type: core.Input }],
            tooltipDismissOnClickOutside: [{ type: core.Input }],
            tooltipOptions: [{ type: core.Input }],
            tooltipEvents: [{ type: core.Output }]
        };
        return NgxBootstrapTooltipDirective;
    }(NgxBootstrapPopup));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxBootstrapPopupModule = /** @class */ (function () {
        function NgxBootstrapPopupModule() {
        }
        NgxBootstrapPopupModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            NgxBootstrapPopupPlaceholderComponent,
                            NgxBootstrapTooltipDirective,
                            NgxBootstrapPopoverDirective,
                        ],
                        imports: [
                            common.CommonModule,
                            observers.ObserversModule
                        ],
                        exports: [
                            NgxBootstrapTooltipDirective,
                            NgxBootstrapPopoverDirective
                        ],
                        entryComponents: [
                            NgxBootstrapPopupPlaceholderComponent
                        ]
                    },] }
        ];
        return NgxBootstrapPopupModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxBootstrapPopoverDirective = NgxBootstrapPopoverDirective;
    exports.NgxBootstrapTooltipDirective = NgxBootstrapTooltipDirective;
    exports.NgxBootstrapPopup = NgxBootstrapPopup;
    exports.NgxBootstrapPopupModule = NgxBootstrapPopupModule;
    exports.ɵa = NgxBootstrapPopupPlaceholderComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=nowzoo-ngx-bootstrap-popup.umd.js.map